#!/usr/bin/python
import os
import re
import sys
import glob
import time
import types
import string 
import urllib
# plugin.py script is based and envolved from Slackcurrent project (http://slackcurrent.sourceforge.net)
# by Eustaquio 'TaQ' Rangel (eustaquiorangel AT yahoo.com)
#__author__ 	= "Eustaquio 'TaQ' Rangel (eustaquiorangel AT yahoo.com)"
#__version__	= "0.1.4"
#__date__		= "$Date: 2006/04/06 12:00:00 - hey, my birthday! :-)$"
#################################################################
# This version of Slackcurrent script has been heavily modified by Mangus&gK 
# for intended use with Kslackcheck tool by Mangus&gK
#Surely I don't expect it works directly.you have been warned.
#__date__			= "$Date: 2006/10/03  22:03:00$"  
#################################################################
# some global vars
_slackcurrent_rc_regex = re.compile("rc[0-9_]{1,3}$")
_slackcurrent_ve_regex = re.compile("([A-Za-z])")
_slackcurrent_rc_like  = {"pre":0,"pl":0,"alpha":0,"beta":100,"rel.":0}
_slackcurrent_lowercase= [c for c in string.lowercase]

# some paths
localpath = "/var/log/packages/"
confpath  = ""
blackpath1 = "/etc/kslackcheck/"
blackpath2 = "../"
#---------------------------------------------------------------------------#
# Class to store info about a package, like name, version, architeture and  #
# build version                                                             #
#---------------------------------------------------------------------------#
class SlackPack:
	""" 
		Create an object with the package info
		The filename MUST have four tokens (returned splitting the file name
		using the '-' delimiter char).
	"""
	def __init__(self,file):
		try:
			self.cversion	= -1
			self.fullpath	= file
			self.file		= file
			self.path		= ""

			# finds the last / position to get the file name
			pos = string.rfind(file,"/")
			if pos>=0:
				self.path = string.strip(file[0:pos])
				self.file = string.strip(file[pos+1:])

			# parse the file name to get it's properties
			tokens = string.split(self.file,"-")

			# needs at least 4 tokens for a valid package
			if(len(tokens)<4):
				throw
			
			self.build		= self.get_build_value(tokens[-1])
			self.arch		= tokens[-2]
			self.version	= tokens[-3]
			self.name		= string.replace(string.join(tokens[0:len(tokens)-3])," ","-")
			self.cversion	= self.make_version()				
			self.valid		= True	
			# print "file:",self.file,"version:",self.version,"cversion:",self.cversion,"build:",self.build
		except StandardError,e:			
			self.valid	= False

	"""
		Returns the build value
	"""
	def get_build_value(self,b):
		# remove the extension from the build
		if string.find(b,".")>=0:
			b = b[0:string.find(b,".")]
		if string.find(b,"_")>=0:
			b = b[0:string.find(b,"_")]
		val = 0
		c = _slackcurrent_ve_regex.sub("",b)
		val = self.get_char_value(c)
		return val

	"""
		When having some letters, try to make an integer with it. If the char is a 
		number, return its integer value.
	"""
	def get_char_value(self,c):
		idx = c
		try:
			idx = _slackcurrent_lowercase.index(c)
		except:
			idx = int(c)
		return idx	

	"""
		Calculate a version based on the package name.
	"""
	def make_version(self):
		try:
			version = []
			version.append(string.zfill("",27))				# version
			version.append(string.zfill("",3))				# rc
			version.append(string.zfill(self.build,3))	# build
			rc = 0
			post = 999
			# replace rc like strings to rc
			# here is a little trick for beta versions - they are like rc versions
			# but it's value is added by 100 - I can't imagine more that 99 alpha
			# versions! :-p
			for t,v in _slackcurrent_rc_like.iteritems():
				if string.find(self.version,t)>=0:
					self.version = string.replace(self.version,t,"rc")
					rc = v

			# check if there is a rc version
			rm = _slackcurrent_rc_regex.search(self.version)
			if rm:
				# did you already saw an underline char (_) on the rc? I did. Argh.
				rc_str = string.replace(self.version[rm.start()+2:],"_","")
				# try to convert the rc to an integer number
				version[1] = string.zfill(int(rc_str)+rc,3)
				self.version = self.version[0:rm.start()]
				post = self.version[rm.start()+2:]

			# check if there is more than 4 version numbers - what kind of
			# freak do that? :-) if found more than 4, concatenate the last ones
			vtokens = string.split(self.version,".")
			if len(vtokens)>4:
				self.version = string.join(vtokens[0:4],".")+string.join(vtokens[4:],'')
			
			v = [string.join(self.make_version_token(t),'') for t in string.split(self.version,".")]
			for i in range(4-len(v)):
				v.append("000000000000")
			version[0] = v[0]+v[1]+v[2]+v[3]
			return long(string.join(version,'')+str(post))
		except StandardError,e:
			return -1

	"""
		Calculate a "version token"
	"""
	def make_version_token(self,token):
		version  = ["000","000","000","000"]
		try:
			versions = [t for t in _slackcurrent_ve_regex.split(token) if len(t)>0]
			for i in range(len(versions)):	
				chr = string.replace(versions[i],"_","")
				version[i] = string.zfill(self.get_char_value(chr),3)
		except StandardError,e:
			pass
		return version

	"""
		Operators overloading for comparison 
	"""
	def __eq__(self,other):
		return self.cversion==other.cversion

	def __gt__(self,other):
		return self.cversion>other.cversion

	def __lt__(self,other):
		return self.cversion<other.cversion
		
	"""
		Return package info as a string
	"""
	def __str__(self):
		return "Package: "+self.name+" Version: "+self.version+"\n"\
				 "Build: "+self.build+" Arch: "+self.arch+"\n"+\
		       "Path   : "+self.path+"\n"+\
				 "Id     : "+str(self.cversion)+"\n"+\
		       "--------------------------------------------------------------------------\n\n"

#---------------------------------------------------------------------------#
# Class to store info about the local packages                              #
#---------------------------------------------------------------------------#
class SlackLocalPacks:
	"""
		Create an object with a list of all the local valid packages on a directory.
	"""	
	def __init__(self,dir):
		list  = glob.glob(dir+"*-*-*-*")
		list.sort()
		packs = [SlackPack(i) for i in list]
		self.packs = [p for p in packs if p.valid]
	
	"""
		Search for a package name on the local list
	"""
	def find(self,package):
		return [p for p in self.packs if p.name==package]

#--------------------------------------------------------------------------------#
#	Class to store info about the remote packages											#
#--------------------------------------------------------------------------------#
class SlackRemotePacks:
	"""
		Create an object with a list of all the local valid packages on the 
		remote server.
	"""	
	def __init__(self,remotelistfile):
		list  = file(remotelistfile,"rb").readlines()
		server= getserver()
		if server[-1]=="/":
			server = server[0:len(server)-1]
		remotelist = [server+r.strip() for r in list]
		remotelist.reverse()
			
		packs = [SlackPack(i) for i in remotelist]
		self.packs = [p for p in packs if p.valid]

	"""
		Search for a package name on the remote list
	"""
	def find(self,package):
		return [p for p in self.packs if p.name==package]

#--------------------------------------------------------------------------------#
#	File path stuff							#
#--------------------------------------------------------------------------------#
"""
	Remote list file path
"""
def remotelistfile():
	return confpath+"remotelist"
def remotelistfile2():
	return confpath+"remotelist2"
"""
	Black list file path
"""
def blacklistfile():
	return blackpath1+"blacklist"
def blacklistfile2():
	return blackpath2+"blacklist"
#--------------------------------------------------------------------------------#
#	Remote stuff																						#
#--------------------------------------------------------------------------------#
"""
	Update the list of remote files 
"""
def updatelist(parms):
	print "Updating the list ..."
	remotelist = downloadremotelist()
	remotelist2 = downloadremotelist2()	
	if remotelist == None:
		return
	open(remotelistfile(),"w").writelines(remotelist)
	open(remotelistfile2(),"w").writelines(remotelist2)	
	print len(remotelist),"items updated"

"""
	Download the remote list from the selected server
"""
def downloadremotelist():
	url = "filelist"
	print "Extracting",url
	expr = re.compile("tgz$")
	pref = re.compile("^http|^ftp")
	try:
		if pref.search(url)!=None:
			oper = urllib.urlopen
		else:	
			oper = open
		remotelist = [r[string.find(r,"/"):] for r in oper(url).readlines() if expr.search(r)!=None]
	except:
		print "Impossible to reach file"
		return None
	return remotelist

def downloadremotelist2():
	url = "filelist"
	expr = re.compile("tgz$")
	pref = re.compile("^http|^ftp")
	try:
		if pref.search(url)!=None:
			oper = urllib.urlopen
		else:
			oper = open
		remotelist2 = [str(int(string.split(r," ")[-4])/1024) + "KB " + r[string.find(r,"/"):] for r in oper(url).readlines() if expr.search(r)!=None]

	except:
		print "Impossible to reach file"
		return None
	return remotelist2
	
#--------------------------------------------------------------------------------#
#	Upgrade stuff, including the testing serie												#
#--------------------------------------------------------------------------------#
def upgradetesting(parms):
	upgrade(parms,True)

#--------------------------------------------------------------------------------#
#	Upgrade stuff																						#
#--------------------------------------------------------------------------------#
"""
	Get local and remote lists, compares it, write to a file and if the user wants,
	show on the screen
"""
def upgrade(parms,testing=False):
	updatelist(None)
	print "Checking packages for upgrade"
	list = getupgradelist(testing)
	if len(list)==0:
		print "No packages for upgrade"
		return

	open("slackcurrent.list","w").writelines(list)
	print "slackpackage list is ready for processing"

"""
	Return the upgrade list
"""
def getupgradelist(testing=False):
	black = getblacklist()
	black2 = getblacklist2()
	local = [p for p in SlackLocalPacks(localpath).packs if p.name not in black and p.name not in black2]
	remote= SlackRemotePacks(remotelistfile())
	expr  = re.compile("^"+getserver())
	test  = re.compile("^"+getserver()+"testing")
	list  = []

	for p in local:
		rmt = remote.find(p.name)
		try:
			if rmt==None or len(rmt)<1:
				continue
			for r in rmt:
				if expr.match(r.fullpath)==None:
					continue
				if not testing and test.match(r.fullpath):
					continue
				if r>p:
					list.append(r.fullpath+"\n")
		except:
			print "ERROR:",p.name,rmt
	return list

#--------------------------------------------------------------------------------#
#	Config stuff																						#
#--------------------------------------------------------------------------------#
"""
	Main method when running from the console
"""
def main(argv):
      	command = argv[1]
		# available commands
	commands= {"-u":upgrade,\
				  "--upgrade":upgrade,
				  "-ut":upgradetesting,\
				  "--upgrade-testing":upgradetesting}

	# execute the desired command	
	if command in commands:
		commands[command](argv)

"""
	Return the selected server
"""
def getserver():
	mirror = sys.argv[3]
	if sys.argv[2]=="f":
		server = mirror+"/slackware-12.0/"
	elif sys.argv[2]=="e":
		server = mirror+"/slackware-10.0/"
	elif sys.argv[2]=="d":
		server = mirror+"/slackware-10.1/"
	elif sys.argv[2]=="c":
		server = mirror+"/slackware-10.2/"
	elif sys.argv[2]=="b":
		server = mirror+"/slackware-11.0/"
	else:
		server = mirror+"/slackware-current/"
	return server

"""
	Return the black list
"""
def getblacklist():
	if not os.path.exists(blacklistfile()):
		return []
	return [r.strip() for r in open(blacklistfile(),"rb").readlines()]
def getblacklist2():
	if not os.path.exists(blacklistfile2()):
		return []
	return [r.strip() for r in open(blacklistfile2(),"rb").readlines()]

if __name__== "__main__":
	main(sys.argv)
